/**
 * OW2 Util
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id: IContainerTransaction.java 4389 2008-12-15 13:48:57Z alitokmen $
 * --------------------------------------------------------------------------
 */

package org.ow2.util.ee.metadata.ejbjar.api.xml.struct;

import java.io.Serializable;
import java.util.List;

import javax.ejb.TransactionAttributeType;

import org.ow2.util.ee.metadata.common.api.xml.struct.IMethodDD;

/**
 * Interface for element container-transaction.
 * @author Florent Benoit
 */
public interface IContainerTransaction extends Serializable {

    /**
     * Name of this element.
     */
    String NAME = "container-transaction";

    /**
     * Add a new Method.
     * @param method the given method.
     */
    void addMethod(final IMethodDD method);

    /**
     * @return list of methods.
     */
    List<IMethodDD> getMethods();

    /**
     * Sets the transaction attribute for this block.
     * @param txAttribute the given transaction attribute
     */
    void setTransactionAttribute(final TransactionAttributeType txAttribute);

    /**
     * Gets the transaction attribute for this block.
     * @return the transaction attribute
     */
    TransactionAttributeType getTransactionAttribute();

    /**
     * @return string representation of this module.
     */
    String toString();

}
